"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = apiGetUser;
const varDatabaseDbHandler_1 = __importDefault(require("../../backend/varDatabaseDbHandler"));
/**
 * # API Get User
 */
function apiGetUser(_a) {
    return __awaiter(this, arguments, void 0, function* ({ fields, dbFullName, userId, }) {
        const finalDbName = dbFullName.replace(/[^a-z0-9_]/g, "");
        const query = `SELECT ${fields.join(",")} FROM ${finalDbName}.users WHERE id=?`;
        const API_USER_ID = userId || process.env.DSQL_API_USER_ID;
        let foundUser = yield (0, varDatabaseDbHandler_1.default)({
            queryString: query,
            queryValuesArray: [API_USER_ID],
            database: finalDbName,
        });
        if (!foundUser || !foundUser[0]) {
            return {
                success: false,
                payload: null,
            };
        }
        return {
            success: true,
            payload: foundUser[0],
        };
    });
}
