"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = varDatabaseDbHandler;
const dbHandler_1 = __importDefault(require("./dbHandler"));
/**
 * # DB handler for specific database
 */
function varDatabaseDbHandler(_a) {
    return __awaiter(this, arguments, void 0, function* ({ queryString, queryValuesArray, }) {
        /**
         * Declare variables
         *
         * @description Declare "results" variable
         */
        let results;
        /**
         * Fetch from db
         *
         * @description Fetch data from db if no cache
         */
        try {
            if (queryString &&
                queryValuesArray &&
                Array.isArray(queryValuesArray) &&
                queryValuesArray[0]) {
                results = yield (0, dbHandler_1.default)({
                    query: queryString,
                    values: queryValuesArray,
                });
            }
            else {
                results = yield (0, dbHandler_1.default)({
                    query: queryString,
                });
            }
            ////////////////////////////////////////
            ////////////////////////////////////////
            ////////////////////////////////////////
        }
        catch ( /** @type {any} */error) {
            console.log("Shell Vardb Error =>", error.message);
        }
        /**
         * Return results
         *
         * @description Return results add to cache if "req" param is passed
         */
        return results;
    });
}
